package dev.k1ll3z.Heroes.skills;

import com.herocraftonline.heroes.Heroes;
import com.herocraftonline.heroes.characters.CharacterManager;
import com.herocraftonline.heroes.characters.Hero;
import com.herocraftonline.heroes.characters.effects.EffectType;
import com.herocraftonline.heroes.characters.skill.*;
import com.herocraftonline.heroes.listeners.HBlockListener;
import com.herocraftonline.heroes.util.Setting;
import com.herocraftonline.heroes.util.Util;
import java.util.Map;
import java.util.Random;

import me.desmin88.mobdisguise.api.MobDisguiseAPI;

import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.PluginManager;

public class SkillDisguise extends PassiveSkill
{
    public class SkillHeroListener
        implements Listener
    {
        public void onPlayerDamage(EntityDamageEvent event)
        {
                Hero hero = plugin.getCharacterManager().getHero((Player)event.getEntity());
                Player player = hero.getPlayer();
                if(MobDisguiseAPI.isDisguised(player))
                {
                	MobDisguiseAPI.undisguisePlayer(player);
                }
            }
    }
    


    public SkillDisguise(Heroes plugin)
    {
        super(plugin, "Disguise");
        setDescription("Allows you to use disguise skills!");
        setEffectTypes(new EffectType[] {
            EffectType.BENEFICIAL
        });
        setTypes(new SkillType[] {
            SkillType.BUFF
        });
        Bukkit.getServer().getPluginManager().registerEvents(new SkillHeroListener(), plugin);
    }

    public ConfigurationSection getDefaultConfig()
    {
        ConfigurationSection node = super.getDefaultConfig();
        return node;
    }

    public String getDescription(Hero hero)
    {

        return getDescription();
    }
}