package dev.k1ll3z.Heroes.skills;

import me.desmin88.mobdisguise.api.MobDisguiseAPI;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.Blaze;
import org.bukkit.entity.CaveSpider;
import org.bukkit.entity.Chicken;
import org.bukkit.entity.Cow;
import org.bukkit.entity.Creeper;
import org.bukkit.entity.Enderman;
import org.bukkit.entity.Ghast;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Pig;
import org.bukkit.entity.PigZombie;
import org.bukkit.entity.Player;
import org.bukkit.entity.Sheep;
import org.bukkit.entity.Silverfish;
import org.bukkit.entity.Skeleton;
import org.bukkit.entity.Slime;
import org.bukkit.entity.Spider;
import org.bukkit.entity.Zombie;

import com.herocraftonline.heroes.Heroes;
import com.herocraftonline.heroes.api.SkillResult;
import com.herocraftonline.heroes.characters.Hero;
import com.herocraftonline.heroes.characters.skill.SkillType;
import com.herocraftonline.heroes.characters.skill.TargettedSkill;

public class SkillTransform extends TargettedSkill
{

    public SkillTransform(Heroes plugin)
    {
        super(plugin, "Transform");
        setDescription("You transform into your target but you turn human upon taking damage!");
        setUsage("/skill transform");
        setArgumentRange(0, 1);
        setIdentifiers(new String[] {
            "skill transform"
        });
        setTypes(new SkillType[] {
           SkillType.SILENCABLE, SkillType.DAMAGING, SkillType.HARMFUL
        });
    }

    public ConfigurationSection getDefaultConfig()
    {
        ConfigurationSection node = super.getDefaultConfig();
        return node;
    }

    public SkillResult use(Hero hero, LivingEntity target, String args[])
    {
        org.bukkit.entity.Player player = hero.getPlayer();
        if(target instanceof Zombie)
        {
        	String mob = "Zombie";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Skeleton)
        {
        	String mob = "Skeleton";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Slime)
        {
        	String mob = "Slime";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Spider)
        {
        	String mob = "Spider";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof PigZombie)
        {
        	String mob = "PigZombie";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Ghast)
        {
        	String mob = "Ghast";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Blaze)
        {
        	String mob = "Blaze";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Creeper)
        {
        	String mob = "Creeper";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Pig)
        {
        	String mob = "Pig";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Sheep)
        {
        	String mob = "Sheep";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Cow)
        {
        	String mob = "Cow";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Enderman)
        {
        	String mob = "Enderman";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Chicken)
        {
        	String mob = "Chicken";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Silverfish)
        {
        	String mob = "Silverfish";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof CaveSpider)
        {
        	String mob = "CaveSpider";
            MobDisguiseAPI.disguisePlayer(player, mob);
        }
        if(target instanceof Player)
        {
        	String human = ((Player) target).getName();
        	MobDisguiseAPI.disguisePlayerAsPlayer(player, human);
        }
        else
        {
        return SkillResult.INVALID_TARGET;
        }
        broadcastExecuteText(hero, target);
        return SkillResult.NORMAL;
    	}

    public String getDescription(Hero hero)
    {
        return getDescription();
    }
}
